
#ifndef _I915_PCIIDS_H
#define _I915_PCIIDS_H


#define INTEL_VGA_DEVICE(id, info) {		\
	0x8086,	id,				\
	~0, ~0,					\
	0x030000, 0xff0000,			\
	(unsigned long) info }

#define INTEL_QUANTA_VGA_DEVICE(info) {		\
	0x8086,	0x16a,				\
	0x152d,	0x8990,				\
	0x030000, 0xff0000,			\
	(unsigned long) info }

#define INTEL_I810_IDS(info)					\
	INTEL_VGA_DEVICE(0x7121, info), 		\
	INTEL_VGA_DEVICE(0x7123, info), 	\
	INTEL_VGA_DEVICE(0x7125, info)  

#define INTEL_I815_IDS(info)					\
	INTEL_VGA_DEVICE(0x1132, info)  

#define INTEL_I830_IDS(info)				\
	INTEL_VGA_DEVICE(0x3577, info)

#define INTEL_I845G_IDS(info)				\
	INTEL_VGA_DEVICE(0x2562, info)

#define INTEL_I85X_IDS(info)				\
	INTEL_VGA_DEVICE(0x3582, info),  \
	INTEL_VGA_DEVICE(0x358e, info)

#define INTEL_I865G_IDS(info)				\
	INTEL_VGA_DEVICE(0x2572, info) 

#define INTEL_I915G_IDS(info)				\
	INTEL_VGA_DEVICE(0x2582, info),  \
	INTEL_VGA_DEVICE(0x258a, info)  

#define INTEL_I915GM_IDS(info)				\
	INTEL_VGA_DEVICE(0x2592, info) 

#define INTEL_I945G_IDS(info)				\
	INTEL_VGA_DEVICE(0x2772, info) 

#define INTEL_I945GM_IDS(info)				\
	INTEL_VGA_DEVICE(0x27a2, info),  \
	INTEL_VGA_DEVICE(0x27ae, info)  

#define INTEL_I965G_IDS(info)				\
	INTEL_VGA_DEVICE(0x2972, info), 	\
	INTEL_VGA_DEVICE(0x2982, info),		\
	INTEL_VGA_DEVICE(0x2992, info),		\
	INTEL_VGA_DEVICE(0x29a2, info)	

#define INTEL_G33_IDS(info)				\
	INTEL_VGA_DEVICE(0x29b2, info),  \
	INTEL_VGA_DEVICE(0x29c2, info),	 \
	INTEL_VGA_DEVICE(0x29d2, info)	

#define INTEL_I965GM_IDS(info)				\
	INTEL_VGA_DEVICE(0x2a02, info),	 \
	INTEL_VGA_DEVICE(0x2a12, info)  

#define INTEL_GM45_IDS(info)				\
	INTEL_VGA_DEVICE(0x2a42, info) 

#define INTEL_G45_IDS(info)				\
	INTEL_VGA_DEVICE(0x2e02, info),  \
	INTEL_VGA_DEVICE(0x2e12, info),  \
	INTEL_VGA_DEVICE(0x2e22, info),  \
	INTEL_VGA_DEVICE(0x2e32, info),  \
	INTEL_VGA_DEVICE(0x2e42, info),  \
	INTEL_VGA_DEVICE(0x2e92, info)	

#define INTEL_PINEVIEW_G_IDS(info) \
	INTEL_VGA_DEVICE(0xa001, info)

#define INTEL_PINEVIEW_M_IDS(info) \
	INTEL_VGA_DEVICE(0xa011, info)

#define INTEL_IRONLAKE_D_IDS(info) \
	INTEL_VGA_DEVICE(0x0042, info)

#define INTEL_IRONLAKE_M_IDS(info) \
	INTEL_VGA_DEVICE(0x0046, info)

#define INTEL_SNB_D_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x0102, info), \
	INTEL_VGA_DEVICE(0x010A, info)

#define INTEL_SNB_D_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x0112, info), \
	INTEL_VGA_DEVICE(0x0122, info)

#define INTEL_SNB_D_IDS(info) \
	INTEL_SNB_D_GT1_IDS(info), \
	INTEL_SNB_D_GT2_IDS(info)

#define INTEL_SNB_M_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x0106, info)

#define INTEL_SNB_M_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x0116, info), \
	INTEL_VGA_DEVICE(0x0126, info)

#define INTEL_SNB_M_IDS(info) \
	INTEL_SNB_M_GT1_IDS(info), \
	INTEL_SNB_M_GT2_IDS(info)

#define INTEL_IVB_M_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x0156, info) 

#define INTEL_IVB_M_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x0166, info) 

#define INTEL_IVB_M_IDS(info) \
	INTEL_IVB_M_GT1_IDS(info), \
	INTEL_IVB_M_GT2_IDS(info)

#define INTEL_IVB_D_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x0152, info),  \
	INTEL_VGA_DEVICE(0x015a, info)  

#define INTEL_IVB_D_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x0162, info),  \
	INTEL_VGA_DEVICE(0x016a, info)  

#define INTEL_IVB_D_IDS(info) \
	INTEL_IVB_D_GT1_IDS(info), \
	INTEL_IVB_D_GT2_IDS(info)

#define INTEL_IVB_Q_IDS(info) \
	INTEL_QUANTA_VGA_DEVICE(info) 

#define INTEL_HSW_ULT_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x0A02, info),  \
	INTEL_VGA_DEVICE(0x0A06, info),  \
	INTEL_VGA_DEVICE(0x0A0A, info),  \
	INTEL_VGA_DEVICE(0x0A0B, info)  

#define INTEL_HSW_ULX_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x0A0E, info) 

#define INTEL_HSW_GT1_IDS(info) \
	INTEL_HSW_ULT_GT1_IDS(info), \
	INTEL_HSW_ULX_GT1_IDS(info), \
	INTEL_VGA_DEVICE(0x0402, info),  \
	INTEL_VGA_DEVICE(0x0406, info),  \
	INTEL_VGA_DEVICE(0x040A, info),  \
	INTEL_VGA_DEVICE(0x040B, info),  \
	INTEL_VGA_DEVICE(0x040E, info),  \
	INTEL_VGA_DEVICE(0x0C02, info),  \
	INTEL_VGA_DEVICE(0x0C06, info),  \
	INTEL_VGA_DEVICE(0x0C0A, info),  \
	INTEL_VGA_DEVICE(0x0C0B, info),  \
	INTEL_VGA_DEVICE(0x0C0E, info),  \
	INTEL_VGA_DEVICE(0x0D02, info),  \
	INTEL_VGA_DEVICE(0x0D06, info), 	\
	INTEL_VGA_DEVICE(0x0D0A, info),  \
	INTEL_VGA_DEVICE(0x0D0B, info),  \
	INTEL_VGA_DEVICE(0x0D0E, info)  

#define INTEL_HSW_ULT_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x0A12, info),  \
	INTEL_VGA_DEVICE(0x0A16, info), 	\
	INTEL_VGA_DEVICE(0x0A1A, info),  \
	INTEL_VGA_DEVICE(0x0A1B, info)   \

#define INTEL_HSW_ULX_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x0A1E, info)  \

#define INTEL_HSW_GT2_IDS(info) \
	INTEL_HSW_ULT_GT2_IDS(info), \
	INTEL_HSW_ULX_GT2_IDS(info), \
	INTEL_VGA_DEVICE(0x0412, info),  \
	INTEL_VGA_DEVICE(0x0416, info),  \
	INTEL_VGA_DEVICE(0x041A, info),  \
	INTEL_VGA_DEVICE(0x041B, info),  \
	INTEL_VGA_DEVICE(0x041E, info),  \
	INTEL_VGA_DEVICE(0x0C12, info),  \
	INTEL_VGA_DEVICE(0x0C16, info),  \
	INTEL_VGA_DEVICE(0x0C1A, info),  \
	INTEL_VGA_DEVICE(0x0C1B, info),  \
	INTEL_VGA_DEVICE(0x0C1E, info),  \
	INTEL_VGA_DEVICE(0x0D12, info),  \
	INTEL_VGA_DEVICE(0x0D16, info),  \
	INTEL_VGA_DEVICE(0x0D1A, info),  \
	INTEL_VGA_DEVICE(0x0D1B, info),  \
	INTEL_VGA_DEVICE(0x0D1E, info)  

#define INTEL_HSW_ULT_GT3_IDS(info) \
	INTEL_VGA_DEVICE(0x0A22, info),  \
	INTEL_VGA_DEVICE(0x0A26, info),  \
	INTEL_VGA_DEVICE(0x0A2A, info),  \
	INTEL_VGA_DEVICE(0x0A2B, info),  \
	INTEL_VGA_DEVICE(0x0A2E, info)  

#define INTEL_HSW_GT3_IDS(info) \
	INTEL_HSW_ULT_GT3_IDS(info), \
	INTEL_VGA_DEVICE(0x0422, info),  \
	INTEL_VGA_DEVICE(0x0426, info),  \
	INTEL_VGA_DEVICE(0x042A, info),  \
	INTEL_VGA_DEVICE(0x042B, info),  \
	INTEL_VGA_DEVICE(0x042E, info),  \
	INTEL_VGA_DEVICE(0x0C22, info),  \
	INTEL_VGA_DEVICE(0x0C26, info),  \
	INTEL_VGA_DEVICE(0x0C2A, info),  \
	INTEL_VGA_DEVICE(0x0C2B, info),  \
	INTEL_VGA_DEVICE(0x0C2E, info),  \
	INTEL_VGA_DEVICE(0x0D22, info),  \
	INTEL_VGA_DEVICE(0x0D26, info),  \
	INTEL_VGA_DEVICE(0x0D2A, info),  \
	INTEL_VGA_DEVICE(0x0D2B, info),  \
	INTEL_VGA_DEVICE(0x0D2E, info)  

#define INTEL_HSW_IDS(info) \
	INTEL_HSW_GT1_IDS(info), \
	INTEL_HSW_GT2_IDS(info), \
	INTEL_HSW_GT3_IDS(info)

#define INTEL_VLV_IDS(info) \
	INTEL_VGA_DEVICE(0x0f30, info), \
	INTEL_VGA_DEVICE(0x0f31, info), \
	INTEL_VGA_DEVICE(0x0f32, info), \
	INTEL_VGA_DEVICE(0x0f33, info)

#define INTEL_BDW_ULT_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x1606, info),  \
	INTEL_VGA_DEVICE(0x160B, info)  

#define INTEL_BDW_ULX_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x160E, info) 

#define INTEL_BDW_GT1_IDS(info) \
	INTEL_BDW_ULT_GT1_IDS(info), \
	INTEL_BDW_ULX_GT1_IDS(info), \
	INTEL_VGA_DEVICE(0x1602, info),  \
	INTEL_VGA_DEVICE(0x160A, info),  \
	INTEL_VGA_DEVICE(0x160D, info)  

#define INTEL_BDW_ULT_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x1616, info),  \
	INTEL_VGA_DEVICE(0x161B, info)  

#define INTEL_BDW_ULX_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x161E, info) 

#define INTEL_BDW_GT2_IDS(info) \
	INTEL_BDW_ULT_GT2_IDS(info), \
	INTEL_BDW_ULX_GT2_IDS(info), \
	INTEL_VGA_DEVICE(0x1612, info), 	\
	INTEL_VGA_DEVICE(0x161A, info),  \
	INTEL_VGA_DEVICE(0x161D, info)  

#define INTEL_BDW_ULT_GT3_IDS(info) \
	INTEL_VGA_DEVICE(0x1626, info),  \
	INTEL_VGA_DEVICE(0x162B, info)   \

#define INTEL_BDW_ULX_GT3_IDS(info) \
	INTEL_VGA_DEVICE(0x162E, info)  

#define INTEL_BDW_GT3_IDS(info) \
	INTEL_BDW_ULT_GT3_IDS(info), \
	INTEL_BDW_ULX_GT3_IDS(info), \
	INTEL_VGA_DEVICE(0x1622, info),  \
	INTEL_VGA_DEVICE(0x162A, info),  \
	INTEL_VGA_DEVICE(0x162D, info)  

#define INTEL_BDW_ULT_RSVD_IDS(info) \
	INTEL_VGA_DEVICE(0x1636, info),  \
	INTEL_VGA_DEVICE(0x163B, info)  

#define INTEL_BDW_ULX_RSVD_IDS(info) \
	INTEL_VGA_DEVICE(0x163E, info) 

#define INTEL_BDW_RSVD_IDS(info) \
	INTEL_BDW_ULT_RSVD_IDS(info), \
	INTEL_BDW_ULX_RSVD_IDS(info), \
	INTEL_VGA_DEVICE(0x1632, info),  \
	INTEL_VGA_DEVICE(0x163A, info),  \
	INTEL_VGA_DEVICE(0x163D, info)  

#define INTEL_BDW_IDS(info) \
	INTEL_BDW_GT1_IDS(info), \
	INTEL_BDW_GT2_IDS(info), \
	INTEL_BDW_GT3_IDS(info), \
	INTEL_BDW_RSVD_IDS(info)

#define INTEL_CHV_IDS(info) \
	INTEL_VGA_DEVICE(0x22b0, info), \
	INTEL_VGA_DEVICE(0x22b1, info), \
	INTEL_VGA_DEVICE(0x22b2, info), \
	INTEL_VGA_DEVICE(0x22b3, info)

#define INTEL_SKL_ULT_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x1906, info),  \
	INTEL_VGA_DEVICE(0x1913, info)  

#define INTEL_SKL_ULX_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x190E, info),  \
	INTEL_VGA_DEVICE(0x1915, info)  

#define INTEL_SKL_GT1_IDS(info)	\
	INTEL_SKL_ULT_GT1_IDS(info), \
	INTEL_SKL_ULX_GT1_IDS(info), \
	INTEL_VGA_DEVICE(0x1902, info),  \
	INTEL_VGA_DEVICE(0x190A, info),  \
	INTEL_VGA_DEVICE(0x190B, info),  \
	INTEL_VGA_DEVICE(0x1917, info)  

#define INTEL_SKL_ULT_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x1916, info),  \
	INTEL_VGA_DEVICE(0x1921, info)  

#define INTEL_SKL_ULX_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x191E, info) 

#define INTEL_SKL_GT2_IDS(info)	\
	INTEL_SKL_ULT_GT2_IDS(info), \
	INTEL_SKL_ULX_GT2_IDS(info), \
	INTEL_VGA_DEVICE(0x1912, info),  \
	INTEL_VGA_DEVICE(0x191A, info),  \
	INTEL_VGA_DEVICE(0x191B, info),  \
	INTEL_VGA_DEVICE(0x191D, info)  

#define INTEL_SKL_ULT_GT3_IDS(info) \
	INTEL_VGA_DEVICE(0x1923, info),  \
	INTEL_VGA_DEVICE(0x1926, info),  \
	INTEL_VGA_DEVICE(0x1927, info)  

#define INTEL_SKL_GT3_IDS(info) \
	INTEL_SKL_ULT_GT3_IDS(info), \
	INTEL_VGA_DEVICE(0x192A, info),  \
	INTEL_VGA_DEVICE(0x192B, info),  \
	INTEL_VGA_DEVICE(0x192D, info)  

#define INTEL_SKL_GT4_IDS(info) \
	INTEL_VGA_DEVICE(0x1932, info),  \
	INTEL_VGA_DEVICE(0x193A, info),  \
	INTEL_VGA_DEVICE(0x193B, info),  \
	INTEL_VGA_DEVICE(0x193D, info) 

#define INTEL_SKL_IDS(info)	 \
	INTEL_SKL_GT1_IDS(info), \
	INTEL_SKL_GT2_IDS(info), \
	INTEL_SKL_GT3_IDS(info), \
	INTEL_SKL_GT4_IDS(info)

#define INTEL_BXT_IDS(info) \
	INTEL_VGA_DEVICE(0x0A84, info), \
	INTEL_VGA_DEVICE(0x1A84, info), \
	INTEL_VGA_DEVICE(0x1A85, info), \
	INTEL_VGA_DEVICE(0x5A84, info),  \
	INTEL_VGA_DEVICE(0x5A85, info)  

#define INTEL_GLK_IDS(info) \
	INTEL_VGA_DEVICE(0x3184, info), \
	INTEL_VGA_DEVICE(0x3185, info)

#define INTEL_KBL_ULT_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x5906, info),  \
	INTEL_VGA_DEVICE(0x5913, info)  

#define INTEL_KBL_ULX_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x590E, info),  \
	INTEL_VGA_DEVICE(0x5915, info)  

#define INTEL_KBL_GT1_IDS(info)	\
	INTEL_KBL_ULT_GT1_IDS(info), \
	INTEL_KBL_ULX_GT1_IDS(info), \
	INTEL_VGA_DEVICE(0x5902, info),  \
	INTEL_VGA_DEVICE(0x5908, info),  \
	INTEL_VGA_DEVICE(0x590A, info),  \
	INTEL_VGA_DEVICE(0x590B, info) 

#define INTEL_KBL_ULT_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x5916, info),  \
	INTEL_VGA_DEVICE(0x5921, info)  

#define INTEL_KBL_ULX_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x591E, info)  

#define INTEL_KBL_GT2_IDS(info)	\
	INTEL_KBL_ULT_GT2_IDS(info), \
	INTEL_KBL_ULX_GT2_IDS(info), \
	INTEL_VGA_DEVICE(0x5912, info),  \
	INTEL_VGA_DEVICE(0x5917, info),  \
	INTEL_VGA_DEVICE(0x591A, info),  \
	INTEL_VGA_DEVICE(0x591B, info),  \
	INTEL_VGA_DEVICE(0x591D, info) 

#define INTEL_KBL_ULT_GT3_IDS(info) \
	INTEL_VGA_DEVICE(0x5926, info) 

#define INTEL_KBL_GT3_IDS(info) \
	INTEL_KBL_ULT_GT3_IDS(info), \
	INTEL_VGA_DEVICE(0x5923, info),  \
	INTEL_VGA_DEVICE(0x5927, info) 

#define INTEL_KBL_GT4_IDS(info) \
	INTEL_VGA_DEVICE(0x593B, info) 


#define INTEL_AML_KBL_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x591C, info),   \
	INTEL_VGA_DEVICE(0x87C0, info) 


#define INTEL_AML_CFL_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x87CA, info)


#define INTEL_CML_GT1_IDS(info)	\
	INTEL_VGA_DEVICE(0x9BA2, info), \
	INTEL_VGA_DEVICE(0x9BA4, info), \
	INTEL_VGA_DEVICE(0x9BA5, info), \
	INTEL_VGA_DEVICE(0x9BA8, info)

#define INTEL_CML_U_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x9B21, info), \
	INTEL_VGA_DEVICE(0x9BAA, info), \
	INTEL_VGA_DEVICE(0x9BAC, info)


#define INTEL_CML_GT2_IDS(info)	\
	INTEL_VGA_DEVICE(0x9BC2, info), \
	INTEL_VGA_DEVICE(0x9BC4, info), \
	INTEL_VGA_DEVICE(0x9BC5, info), \
	INTEL_VGA_DEVICE(0x9BC6, info), \
	INTEL_VGA_DEVICE(0x9BC8, info), \
	INTEL_VGA_DEVICE(0x9BE6, info), \
	INTEL_VGA_DEVICE(0x9BF6, info)

#define INTEL_CML_U_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x9B41, info), \
	INTEL_VGA_DEVICE(0x9BCA, info), \
	INTEL_VGA_DEVICE(0x9BCC, info)

#define INTEL_KBL_IDS(info) \
	INTEL_KBL_GT1_IDS(info), \
	INTEL_KBL_GT2_IDS(info), \
	INTEL_KBL_GT3_IDS(info), \
	INTEL_KBL_GT4_IDS(info), \
	INTEL_AML_KBL_GT2_IDS(info)


#define INTEL_CFL_S_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x3E90, info),  \
	INTEL_VGA_DEVICE(0x3E93, info),  \
	INTEL_VGA_DEVICE(0x3E99, info)  

#define INTEL_CFL_S_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x3E91, info),  \
	INTEL_VGA_DEVICE(0x3E92, info),  \
	INTEL_VGA_DEVICE(0x3E96, info),  \
	INTEL_VGA_DEVICE(0x3E98, info),  \
	INTEL_VGA_DEVICE(0x3E9A, info)  


#define INTEL_CFL_H_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x3E9C, info)

#define INTEL_CFL_H_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x3E94, info),   \
	INTEL_VGA_DEVICE(0x3E9B, info) 


#define INTEL_CFL_U_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x3EA9, info)


#define INTEL_CFL_U_GT3_IDS(info) \
	INTEL_VGA_DEVICE(0x3EA5, info),  \
	INTEL_VGA_DEVICE(0x3EA6, info),  \
	INTEL_VGA_DEVICE(0x3EA7, info),  \
	INTEL_VGA_DEVICE(0x3EA8, info)  


#define INTEL_WHL_U_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x3EA1, info), \
	INTEL_VGA_DEVICE(0x3EA4, info)


#define INTEL_WHL_U_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x3EA0, info), \
	INTEL_VGA_DEVICE(0x3EA3, info)


#define INTEL_WHL_U_GT3_IDS(info) \
	INTEL_VGA_DEVICE(0x3EA2, info)

#define INTEL_CFL_IDS(info)	   \
	INTEL_CFL_S_GT1_IDS(info), \
	INTEL_CFL_S_GT2_IDS(info), \
	INTEL_CFL_H_GT1_IDS(info), \
	INTEL_CFL_H_GT2_IDS(info), \
	INTEL_CFL_U_GT2_IDS(info), \
	INTEL_CFL_U_GT3_IDS(info), \
	INTEL_WHL_U_GT1_IDS(info), \
	INTEL_WHL_U_GT2_IDS(info), \
	INTEL_WHL_U_GT3_IDS(info), \
	INTEL_AML_CFL_GT2_IDS(info), \
	INTEL_CML_GT1_IDS(info), \
	INTEL_CML_GT2_IDS(info), \
	INTEL_CML_U_GT1_IDS(info), \
	INTEL_CML_U_GT2_IDS(info)


#define INTEL_CNL_PORT_F_IDS(info) \
	INTEL_VGA_DEVICE(0x5A44, info), \
	INTEL_VGA_DEVICE(0x5A4C, info), \
	INTEL_VGA_DEVICE(0x5A54, info), \
	INTEL_VGA_DEVICE(0x5A5C, info)

#define INTEL_CNL_IDS(info) \
	INTEL_CNL_PORT_F_IDS(info), \
	INTEL_VGA_DEVICE(0x5A40, info), \
	INTEL_VGA_DEVICE(0x5A41, info), \
	INTEL_VGA_DEVICE(0x5A42, info), \
	INTEL_VGA_DEVICE(0x5A49, info), \
	INTEL_VGA_DEVICE(0x5A4A, info), \
	INTEL_VGA_DEVICE(0x5A50, info), \
	INTEL_VGA_DEVICE(0x5A51, info), \
	INTEL_VGA_DEVICE(0x5A52, info), \
	INTEL_VGA_DEVICE(0x5A59, info), \
	INTEL_VGA_DEVICE(0x5A5A, info)


#define INTEL_ICL_PORT_F_IDS(info) \
	INTEL_VGA_DEVICE(0x8A50, info), \
	INTEL_VGA_DEVICE(0x8A52, info), \
	INTEL_VGA_DEVICE(0x8A53, info), \
	INTEL_VGA_DEVICE(0x8A54, info), \
	INTEL_VGA_DEVICE(0x8A56, info), \
	INTEL_VGA_DEVICE(0x8A57, info), \
	INTEL_VGA_DEVICE(0x8A58, info),	\
	INTEL_VGA_DEVICE(0x8A59, info),	\
	INTEL_VGA_DEVICE(0x8A5A, info), \
	INTEL_VGA_DEVICE(0x8A5B, info), \
	INTEL_VGA_DEVICE(0x8A5C, info), \
	INTEL_VGA_DEVICE(0x8A70, info), \
	INTEL_VGA_DEVICE(0x8A71, info)

#define INTEL_ICL_11_IDS(info) \
	INTEL_ICL_PORT_F_IDS(info), \
	INTEL_VGA_DEVICE(0x8A51, info), \
	INTEL_VGA_DEVICE(0x8A5D, info)


#define INTEL_EHL_IDS(info) \
	INTEL_VGA_DEVICE(0x4541, info), \
	INTEL_VGA_DEVICE(0x4551, info), \
	INTEL_VGA_DEVICE(0x4555, info), \
	INTEL_VGA_DEVICE(0x4557, info), \
	INTEL_VGA_DEVICE(0x4571, info)


#define INTEL_JSL_IDS(info) \
	INTEL_VGA_DEVICE(0x4E51, info), \
	INTEL_VGA_DEVICE(0x4E55, info), \
	INTEL_VGA_DEVICE(0x4E57, info), \
	INTEL_VGA_DEVICE(0x4E61, info), \
	INTEL_VGA_DEVICE(0x4E71, info)


#define INTEL_TGL_12_GT1_IDS(info) \
	INTEL_VGA_DEVICE(0x9A60, info), \
	INTEL_VGA_DEVICE(0x9A68, info), \
	INTEL_VGA_DEVICE(0x9A70, info)

#define INTEL_TGL_12_GT2_IDS(info) \
	INTEL_VGA_DEVICE(0x9A40, info), \
	INTEL_VGA_DEVICE(0x9A49, info), \
	INTEL_VGA_DEVICE(0x9A59, info), \
	INTEL_VGA_DEVICE(0x9A78, info), \
	INTEL_VGA_DEVICE(0x9AC0, info), \
	INTEL_VGA_DEVICE(0x9AC9, info), \
	INTEL_VGA_DEVICE(0x9AD9, info), \
	INTEL_VGA_DEVICE(0x9AF8, info)

#define INTEL_TGL_12_IDS(info) \
	INTEL_TGL_12_GT1_IDS(info), \
	INTEL_TGL_12_GT2_IDS(info)


#define INTEL_RKL_IDS(info) \
	INTEL_VGA_DEVICE(0x4C80, info), \
	INTEL_VGA_DEVICE(0x4C8A, info), \
	INTEL_VGA_DEVICE(0x4C8B, info), \
	INTEL_VGA_DEVICE(0x4C8C, info), \
	INTEL_VGA_DEVICE(0x4C90, info), \
	INTEL_VGA_DEVICE(0x4C9A, info)


#define INTEL_DG1_IDS(info) \
	INTEL_VGA_DEVICE(0x4905, info), \
	INTEL_VGA_DEVICE(0x4906, info), \
	INTEL_VGA_DEVICE(0x4907, info), \
	INTEL_VGA_DEVICE(0x4908, info), \
	INTEL_VGA_DEVICE(0x4909, info)


#define INTEL_ADLS_IDS(info) \
	INTEL_VGA_DEVICE(0x4680, info), \
	INTEL_VGA_DEVICE(0x4682, info), \
	INTEL_VGA_DEVICE(0x4688, info), \
	INTEL_VGA_DEVICE(0x468A, info), \
	INTEL_VGA_DEVICE(0x468B, info), \
	INTEL_VGA_DEVICE(0x4690, info), \
	INTEL_VGA_DEVICE(0x4692, info), \
	INTEL_VGA_DEVICE(0x4693, info)


#define INTEL_ADLP_IDS(info) \
	INTEL_VGA_DEVICE(0x46A0, info), \
	INTEL_VGA_DEVICE(0x46A1, info), \
	INTEL_VGA_DEVICE(0x46A2, info), \
	INTEL_VGA_DEVICE(0x46A3, info), \
	INTEL_VGA_DEVICE(0x46A6, info), \
	INTEL_VGA_DEVICE(0x46A8, info), \
	INTEL_VGA_DEVICE(0x46AA, info), \
	INTEL_VGA_DEVICE(0x462A, info), \
	INTEL_VGA_DEVICE(0x4626, info), \
	INTEL_VGA_DEVICE(0x4628, info), \
	INTEL_VGA_DEVICE(0x46B0, info), \
	INTEL_VGA_DEVICE(0x46B1, info), \
	INTEL_VGA_DEVICE(0x46B2, info), \
	INTEL_VGA_DEVICE(0x46B3, info), \
	INTEL_VGA_DEVICE(0x46C0, info), \
	INTEL_VGA_DEVICE(0x46C1, info), \
	INTEL_VGA_DEVICE(0x46C2, info), \
	INTEL_VGA_DEVICE(0x46C3, info)


#define INTEL_ADLN_IDS(info) \
	INTEL_VGA_DEVICE(0x46D0, info), \
	INTEL_VGA_DEVICE(0x46D1, info), \
	INTEL_VGA_DEVICE(0x46D2, info)


#define INTEL_RPLS_IDS(info) \
	INTEL_VGA_DEVICE(0xA780, info), \
	INTEL_VGA_DEVICE(0xA781, info), \
	INTEL_VGA_DEVICE(0xA782, info), \
	INTEL_VGA_DEVICE(0xA783, info), \
	INTEL_VGA_DEVICE(0xA788, info), \
	INTEL_VGA_DEVICE(0xA789, info), \
	INTEL_VGA_DEVICE(0xA78A, info), \
	INTEL_VGA_DEVICE(0xA78B, info)


#define INTEL_RPLP_IDS(info) \
	INTEL_VGA_DEVICE(0xA720, info), \
	INTEL_VGA_DEVICE(0xA721, info), \
	INTEL_VGA_DEVICE(0xA7A0, info), \
	INTEL_VGA_DEVICE(0xA7A1, info), \
	INTEL_VGA_DEVICE(0xA7A8, info), \
	INTEL_VGA_DEVICE(0xA7A9, info)


#define INTEL_DG2_G10_IDS(info) \
	INTEL_VGA_DEVICE(0x5690, info), \
	INTEL_VGA_DEVICE(0x5691, info), \
	INTEL_VGA_DEVICE(0x5692, info), \
	INTEL_VGA_DEVICE(0x56A0, info), \
	INTEL_VGA_DEVICE(0x56A1, info), \
	INTEL_VGA_DEVICE(0x56A2, info)

#define INTEL_DG2_G11_IDS(info) \
	INTEL_VGA_DEVICE(0x5693, info), \
	INTEL_VGA_DEVICE(0x5694, info), \
	INTEL_VGA_DEVICE(0x5695, info), \
	INTEL_VGA_DEVICE(0x56A5, info), \
	INTEL_VGA_DEVICE(0x56A6, info), \
	INTEL_VGA_DEVICE(0x56B0, info), \
	INTEL_VGA_DEVICE(0x56B1, info)

#define INTEL_DG2_G12_IDS(info) \
	INTEL_VGA_DEVICE(0x5696, info), \
	INTEL_VGA_DEVICE(0x5697, info), \
	INTEL_VGA_DEVICE(0x56A3, info), \
	INTEL_VGA_DEVICE(0x56A4, info), \
	INTEL_VGA_DEVICE(0x56B2, info), \
	INTEL_VGA_DEVICE(0x56B3, info)

#define INTEL_DG2_IDS(info) \
	INTEL_DG2_G10_IDS(info), \
	INTEL_DG2_G11_IDS(info), \
	INTEL_DG2_G12_IDS(info)

#define INTEL_ATS_M150_IDS(info) \
	INTEL_VGA_DEVICE(0x56C0, info)

#define INTEL_ATS_M75_IDS(info) \
	INTEL_VGA_DEVICE(0x56C1, info)

#define INTEL_ATS_M_IDS(info) \
	INTEL_ATS_M150_IDS(info), \
	INTEL_ATS_M75_IDS(info)

#define INTEL_MTL_M_IDS(info) \
	INTEL_VGA_DEVICE(0x7D40, info), \
	INTEL_VGA_DEVICE(0x7D60, info)

#define INTEL_MTL_P_IDS(info) \
	INTEL_VGA_DEVICE(0x7D45, info), \
	INTEL_VGA_DEVICE(0x7D55, info), \
	INTEL_VGA_DEVICE(0x7DD5, info)

#define INTEL_MTL_IDS(info) \
	INTEL_MTL_M_IDS(info), \
	INTEL_MTL_P_IDS(info)

#endif 
