/* SPDX-License-Identifier: GPL-2.0 */
#ifndef _LINUX_SCHED_PRIO_H
#define _LINUX_SCHED_PRIO_H

#define MAX_NICE	19
#define MIN_NICE	-20
#define NICE_WIDTH	(MAX_NICE - MIN_NICE + 1)



#define MAX_RT_PRIO		100

#define MAX_PRIO		(MAX_RT_PRIO + NICE_WIDTH)
#define DEFAULT_PRIO		(MAX_RT_PRIO + NICE_WIDTH / 2)

#ifdef CONFIG_SCHED_ALT


#undef MAX_PRIO
#undef DEFAULT_PRIO


#ifdef CONFIG_SCHED_BMQ
#define MAX_PRIORITY_ADJ	(7)

#define MIN_NORMAL_PRIO		(MAX_RT_PRIO)
#define MAX_PRIO		(MIN_NORMAL_PRIO + NICE_WIDTH)
#define DEFAULT_PRIO		(MIN_NORMAL_PRIO + NICE_WIDTH / 2)
#endif

#ifdef CONFIG_SCHED_PDS
#define MAX_PRIORITY_ADJ	(0)

#define MIN_NORMAL_PRIO		(128)
#define NORMAL_PRIO_NUM		(64)
#define MAX_PRIO		(MIN_NORMAL_PRIO + NORMAL_PRIO_NUM)
#define DEFAULT_PRIO		(MAX_PRIO - NICE_WIDTH / 2)
#endif

#endif 


#define NICE_TO_PRIO(nice)	((nice) + DEFAULT_PRIO)
#define PRIO_TO_NICE(prio)	((prio) - DEFAULT_PRIO)


static inline long nice_to_rlimit(long nice)
{
	return (MAX_NICE - nice + 1);
}


static inline long rlimit_to_nice(long prio)
{
	return (MAX_NICE - prio + 1);
}

#endif 
